// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlShortcutSimpleLabel")]
    pub struct ShortcutSimpleLabel(Object<ffi::DzlShortcutSimpleLabel, ffi::DzlShortcutSimpleLabelClass>) @extends gtk::Box, gtk::Container, gtk::Widget, @implements gtk::Buildable, gtk::Orientable;

    match fn {
        type_ => || ffi::dzl_shortcut_simple_label_get_type(),
    }
}

impl ShortcutSimpleLabel {
    #[doc(alias = "dzl_shortcut_simple_label_new")]
    pub fn new() -> ShortcutSimpleLabel {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_shortcut_simple_label_new()).unsafe_cast() }
    }

    #[doc(alias = "dzl_shortcut_simple_label_get_accel")]
    #[doc(alias = "get_accel")]
    pub fn accel(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::dzl_shortcut_simple_label_get_accel(
                self.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_shortcut_simple_label_get_action")]
    #[doc(alias = "get_action")]
    pub fn action(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::dzl_shortcut_simple_label_get_action(
                self.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_shortcut_simple_label_get_command")]
    #[doc(alias = "get_command")]
    pub fn command(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::dzl_shortcut_simple_label_get_command(
                self.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_shortcut_simple_label_get_title")]
    #[doc(alias = "get_title")]
    pub fn title(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::dzl_shortcut_simple_label_get_title(
                self.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_shortcut_simple_label_set_accel")]
    pub fn set_accel(&self, accel: &str) {
        unsafe {
            ffi::dzl_shortcut_simple_label_set_accel(self.to_glib_none().0, accel.to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_shortcut_simple_label_set_action")]
    pub fn set_action(&self, action: &str) {
        unsafe {
            ffi::dzl_shortcut_simple_label_set_action(
                self.to_glib_none().0,
                action.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "dzl_shortcut_simple_label_set_command")]
    pub fn set_command(&self, command: &str) {
        unsafe {
            ffi::dzl_shortcut_simple_label_set_command(
                self.to_glib_none().0,
                command.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "dzl_shortcut_simple_label_set_title")]
    pub fn set_title(&self, title: &str) {
        unsafe {
            ffi::dzl_shortcut_simple_label_set_title(self.to_glib_none().0, title.to_glib_none().0);
        }
    }

    #[doc(alias = "show-accel")]
    pub fn shows_accel(&self) -> bool {
        ObjectExt::property(self, "show-accel")
    }

    #[doc(alias = "show-accel")]
    pub fn set_show_accel(&self, show_accel: bool) {
        ObjectExt::set_property(self, "show-accel", show_accel)
    }

    #[doc(alias = "accel")]
    pub fn connect_accel_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_accel_trampoline<F: Fn(&ShortcutSimpleLabel) + 'static>(
            this: *mut ffi::DzlShortcutSimpleLabel,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::accel\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_accel_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "action")]
    pub fn connect_action_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_action_trampoline<F: Fn(&ShortcutSimpleLabel) + 'static>(
            this: *mut ffi::DzlShortcutSimpleLabel,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::action\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_action_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "command")]
    pub fn connect_command_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_command_trampoline<F: Fn(&ShortcutSimpleLabel) + 'static>(
            this: *mut ffi::DzlShortcutSimpleLabel,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::command\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_command_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "show-accel")]
    pub fn connect_show_accel_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_show_accel_trampoline<F: Fn(&ShortcutSimpleLabel) + 'static>(
            this: *mut ffi::DzlShortcutSimpleLabel,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::show-accel\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_show_accel_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "title")]
    pub fn connect_title_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_title_trampoline<F: Fn(&ShortcutSimpleLabel) + 'static>(
            this: *mut ffi::DzlShortcutSimpleLabel,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::title\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_title_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl Default for ShortcutSimpleLabel {
    fn default() -> Self {
        Self::new()
    }
}

impl fmt::Display for ShortcutSimpleLabel {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("ShortcutSimpleLabel")
    }
}
